import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
 
/**
 * This class basically is a utility class for performing serialization and
 * de-serialization processes when provided the required information.
 *
 */
public class Serialutil {
 
    /**
     * To de-serialize to object from a given file, we use the general object 
     * so that it works for all Java classes. */
    public static Object deserialize(String filename) throws IOException,
            ClassNotFoundException {
        FileInputStream finputs = new FileInputStream(filename);
        BufferedInputStream binputs = new BufferedInputStream(finputs);
        ObjectInputStream oinputs = new ObjectInputStream(binputs);
        Object objt = oinputs.readObject();
        oinputs.close();
        return objt;
    }
 
    /**
     * Serializing the given object and saving it to a given file
     */
    public static void serialize(Object objt, String filename)
            throws IOException {
        FileOutputStream foutputs = new FileOutputStream(filename);
        BufferedOutputStream boutputs = new BufferedOutputStream(foutputs);
        ObjectOutputStream ooutputs = new ObjectOutputStream(boutputs);
        ooutputs.writeObject(objt);
        ooutputs.close();
    }
}
